<?php 
include("../glbinc.inc");

include($inc_path."fpdf/chinese.php");


//==========pdf class


class PDF_MySQL_Table extends PDF_Chinese
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;
var $db = null;//adodb
function setdb(&$conn)
{
	    if ($conn){
               $this->db = $conn;
          /*選擇存取的table files*/
        } else {
           if (!$conn) {
            die('連線尚未設定!');
           } else {
            die ('找不到資料庫!');
           }
	    }
}
function Header()
{
    //Print the table header if necessary
    if($this->ProcessingTable)
        $this->TableHeader();
}

function TableHeader()
{
    $this->SetFont('uni','B',12);
    $this->SetX($this->TableX);
    $fill=!empty($this->HeaderColor);
    if($fill)
        $this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
    foreach($this->aCols as $col)
        $this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
    $this->Ln();
}

function Row($data)
{
    $this->SetX($this->TableX);
    $ci=$this->ColorIndex;
    $fill=!empty($this->RowColors[$ci]);
    if($fill)
        $this->SetFillColor($this->RowColors[$ci][0],$this->RowColors[$ci][1],$this->RowColors[$ci][2]);
    foreach($this->aCols as $col)
    {
	if(!is_array($col['r'])){
        $this->Cell($col['w'],5,$data[$col['f']],1,0,$col['a'],$fill);
	}else{
	  $refn=$col['r'];
	  //global $$refn;
	  //$refname=$$refn;
        $this->Cell($col['w'],5,$refn[$data[$col['f']]],1,0,$col['a'],$fill);		
	}
    }
    $this->Ln();
    $this->ColorIndex=1-$ci;
}

function CalcWidths($width,$align)
{
    //Compute the widths of the columns
    $TableWidth=0;
    foreach($this->aCols as $i=>$col)
    {
        $w=$col['w'];
        if($w==-1)
            $w=$width/count($this->aCols);
        elseif(substr($w,-1)=='%')
            $w=$w/100*$width;
        $this->aCols[$i]['w']=$w;
        $TableWidth+=$w;
    }
    //Compute the abscissa of the table
    if($align=='C')
        $this->TableX=max(($this->w-$TableWidth)/2,0);
    elseif($align=='R')
        $this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
    else
        $this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align='L',$ref='')
{
    //Add a column to the table
    if($field==-1)
        $field=count($this->aCols);
    $this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align,'r'=>$ref);
}

function Table($query,$prop=array())
{
	global $conn;
	if(!empty($conn)){$this->setdb($conn);}
    //Issue query
    $res=$this->db->Execute($query) or die('Error: '.mysql_error()."<BR>Query: $query");
    //Add all columns if none was specified
    if(count($this->aCols)==0)
    {
        //$nb=mysql_num_fields($res);
		$nb=$res->FieldCount();
        for($i=0;$i<$nb;$i++)
            $this->AddCol();
    }
    //Retrieve column names when not specified
    foreach($this->aCols as $i=>$col)
    {
        if($col['c']=='')
        {
            if(is_string($col['f'])){
                $this->aCols[$i]['c']=ucfirst($col['f']);
            }else{
                //$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
                  $fj  = $res->FetchField($col['f']);
			    $this->aCols[$i]['c']=ucfirst($fj->name);
			}
        }
    }
    //Handle properties
    if(!isset($prop['width']))
        $prop['width']=0;
    if($prop['width']==0)
        $prop['width']=$this->w-$this->lMargin-$this->rMargin;
    if(!isset($prop['align']))
        $prop['align']='C';
    if(!isset($prop['padding']))
        $prop['padding']=$this->cMargin;
    $cMargin=$this->cMargin;
    $this->cMargin=$prop['padding'];
    if(!isset($prop['HeaderColor']))
        $prop['HeaderColor']=array();
    $this->HeaderColor=$prop['HeaderColor'];
    if(!isset($prop['color1']))
        $prop['color1']=array();
    if(!isset($prop['color2']))
        $prop['color2']=array();
    $this->RowColors=array($prop['color1'],$prop['color2']);
    //Compute column widths
    $this->CalcWidths($prop['width'],$prop['align']);
    //Print header
    $this->TableHeader();
    //Print rows
    $this->SetFont('uni','',11);
    $this->ColorIndex=0;
    $this->ProcessingTable=true;
	//while($row=mysql_fetch_array($res))
	while($row=$res->FetchRow())
            $this->Row($row);
    $this->ProcessingTable=false;
    $this->cMargin=$cMargin;
    $this->aCols=array();
}
}
class PDF extends PDF_MySQL_Table
{
var $title,$pgname,$cond;
function Header()
{
    //Title
    /*
    $this->SetTextColor(0,0,0);
	$this->setX($this->tableX);
    $this->SetFont('uni','B',14);
    $this->Cell(0,6,$this->title,0,1,'C');
    $this->SetFont('uni','B',11);
    $this->Ln(2);
    //$this->SetFont('Arial','',18);
//	$this->setX($this->lMargin);
//	$ptime='印表時間: '.date("Y/m/d H:i");
//	$this->Cell(10,6,$ptime,0,0,'L');
	$this->setX($this->tableX);
  //$this->Cell(0,6,$this->pgname,0,0,'C');
  $this->Cell(0,6,"旅客登記表",0,0,'C');
//	$this->setX($this->rMargin-50);
//	$this->Cell(0,6,'頁次: '.$this->PageNo().'/'.$this->page,0,0,'L');
//	$this->Cell(0,6,'頁次: '.$this->PageNo().'/'.$this->page,0,0,'L');
    $this->Ln();
    */
//	$this->Cell(10,6,$this->cond,0,0,'L');
//    $this->Ln();
    //==========Column Header
    /*
    $this->SetFont('uni','',11);
	$this->Cell(40,6,'券別',1,0,'L');
	$this->Cell(35,6,'類別',1,0,'L');
	$this->Cell(35,6,'券號',1,0,'L');
	$this->Cell(35,6,'使用時間',1,0,'L');
	$this->Cell(30,6,'折價券金額',1,0,'C');
	$this->Cell(30,6,'抵用金額',1,0,'C');
  $this->Ln();
  */
    //Ensure table header is output
    parent::Header();
}
}

//====end class
  $querystr='';
 if (empty($s_date)) $s_date=date("Y-m-d");
 if (empty($e_date)) $e_date=date("Y-m-d");
 //$sql="select * from greserv where hid='$hid'  and v_type!='A' and rd_cidate between '$s_date' and '$e_date' and rd_status in ('Y') order by v_type,rd_cidate,stoke,v_name ";
 $sql="select * from greserv where hid='$hid' and rd_cidate between '$s_date' and '$e_date' and rd_status in ('Y') order by v_type,rd_cidate,stoke,v_name ";
 $rs= &$conn->Execute($sql);
 if( empty($rs)){
    echo $strMeta."<script> alert('greserv 錯誤'); </script> ";
    exit;
 }
		       /*
		       $c_addr=$rs->fields('c_addr');
		       $rd_remark=$rs->fields('rd_remark');
		       $v_birth='';
		       if (!empty($v_idno)) {
		         if ($v_type=='C') {
		           $sqlx="select v_birth from custmaster where v_idno='$v_idno' ";
		           $rsx=$conn->Execute($sqlx);
		           if (!$rsx->EOF) {
		             $v_birth=$rsx->fields('v_birth');
               }
               $rsx->Close();
		         }
           }
           */
           $sqlx="select sum(fee_amt-back_fee) rd_fee from reserfee where prd_no='$prd_no' ";
           $rsx=$conn->Execute($sqlx);
           $rd_fee=0;
           if (!$rsx->EOF) {
             $rd_fee=$rsx->fields('rd_fee');
           }
           $rsx->Close();
/*
           $sql2="select * from agency where hid='$hid' and ag_code='$v_idno' ";
           $rs2= &$conn->Execute($sql2);
           $ag_name=$rs2->fields("ag_name");
*/           
   /******************************************/
//    saymsg("soyalsql = $soyalsql");
/*
  $rs=&$conn->Execute($sql);
  if (!$rs) {
        print ($strMeta."<h3>(HFS50GS).</h3><br>".$conn->ErrorMsg());
        exit;
    }
 $sql="select * from prechkin where res_no = '$prd_no'  group by room_no order by room_no ";
 $rs= &$conn->Execute($sql);
 if( empty($rs)){
    echo $strMeta."<script> alert('prechkin 錯誤'); </script> ";
    exit;
 }
  if ($rs->rowcount()==0) {
        print ($strMeta."<h3>查 無 預 排 房 資 料.</h3><br>");
        exit;
    }
*/
//=======================
//====開啟pdf
//$xylen=array(110.0,155.0);//25.54*6=155
$xylen=array(215.9,140.0);  // 中一刀
$pdf=new PDF("P","mm",$xylen);
//if (empty($p_size)) $p_size='a4';
//$pdf=new PDF("P","mm",$p_size);
//$pdf->SetFontSize(14);
$pdf->AddBig5Font();
$pdf->Open();
$sqlstr="select * from admsetup";
$rsstr=&$conn->Execute($sqlstr);
if ($rsstr->Rowcount()==0) {
	$pdf->title='admsetup 無公司名稱';
} else {
        $pdf->title=$rsstr->fields("hname");
}	

	$pdf->AddPage();
	$pdf->AliasNbPages();
	$pdf->SetAutoPageBreak(false,3);
	
	$lwidth=$pdf->w - $pdf->lMargin;
     $marX=18;
     $marY=18;
	while (!$rs->EOF) {
    $rid=$rs->fields("rid");
    $rd_cidate=$rs->fields("rd_cidate");
    $rd_codate=$rs->fields("rd_codate");
    $v_type=$rs->fields("v_type");
    $v_name=$rs->fields("v_name");
    $v_idno=$rs->fields("v_idno");
    $prd_no=$rs->fields("prd_no");
    $c_tel=$rs->fields('c_tel');
           $sqlx="select sum(rd_fee-back_fee) rd_fee from reserfee where prd_no='$prd_no' ";
           $rsx=$conn->Execute($sqlx);
           $rd_fee=0;
           if (!$rsx->EOF) {
             $rd_fee=$rsx->fields('rd_fee');
           }
           $rsx->Close();
    $pdf->SetFont('uni','B',14);

    // $pdf->SetXY(40+$marX,25+$marY);
    $pdf->SetXY(20+$marX,25+$marY);
		//$pdf->Cell(20,6,"G".$rid,0,0,'L');
		$pdf->Cell(20,6,"G".$rid." $v_name",0,0,'L');
    $pdf->SetXY(21+$marX,43+$marY);
		$pdf->Cell(50,6,"$v_idno",0,0,'L');
    $pdf->SetXY(80+$marX,43+$marY);
		$pdf->Cell(44,6,"$c_tel",0,0,'L');
    //$pdf->SetXY(190+$marX,42+$marY);
		//$pdf->Cell(25,6,"$rd_fee",0,0,'L');
    $pdf->SetXY(15+$marX,100+$marY);
		$pdf->Cell(20,6,"$rd_cidate",0,0,'L');
    $pdf->SetXY(45+$marX,100+$marY);
		$pdf->Cell(20,6,"$rd_codate",0,0,'L');
		$rs->MoveNext();
		$irc++;
		if (!$rs->EOF) 
	    $pdf->AddPage();
		
	}
	$rs->Close();
//	$pdf->SetFont('uni','B',11);
//	$pdf->Cell(0,6,">>>共 $rows 筆<<<",0,1,'C');
  $pdf->SetDisplayMode(75);
	$pdf->Output();
?>
