<?php 
include("../glbinc.inc");

include($inc_path."fpdf/chinese.php");


//==========pdf class


class PDF_MySQL_Table extends PDF_Chinese
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;
var $db = null;//adodb
function setdb(&$conn)
{
	    if ($conn){
               $this->db = $conn;
          /*選擇存取的table files*/
        } else {
           if (!$conn) {
            die('連線尚未設定!');
           } else {
            die ('找不到資料庫!');
           }
	    }
}
function Header()
{
    //Print the table header if necessary
    if($this->ProcessingTable)
        $this->TableHeader();
}

function TableHeader()
{
    $this->SetFont('uni','B',12);
    $this->SetX($this->TableX);
    $fill=!empty($this->HeaderColor);
    if($fill)
        $this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
    foreach($this->aCols as $col)
        $this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
    $this->Ln();
}

function Row($data)
{
    $this->SetX($this->TableX);
    $ci=$this->ColorIndex;
    $fill=!empty($this->RowColors[$ci]);
    if($fill)
        $this->SetFillColor($this->RowColors[$ci][0],$this->RowColors[$ci][1],$this->RowColors[$ci][2]);
    foreach($this->aCols as $col)
    {
	if(!is_array($col['r'])){
        $this->Cell($col['w'],5,$data[$col['f']],1,0,$col['a'],$fill);
	}else{
	  $refn=$col['r'];
	  //global $$refn;
	  //$refname=$$refn;
        $this->Cell($col['w'],5,$refn[$data[$col['f']]],1,0,$col['a'],$fill);		
	}
    }
    $this->Ln();
    $this->ColorIndex=1-$ci;
}

function CalcWidths($width,$align)
{
    //Compute the widths of the columns
    $TableWidth=0;
    foreach($this->aCols as $i=>$col)
    {
        $w=$col['w'];
        if($w==-1)
            $w=$width/count($this->aCols);
        elseif(substr($w,-1)=='%')
            $w=$w/100*$width;
        $this->aCols[$i]['w']=$w;
        $TableWidth+=$w;
    }
    //Compute the abscissa of the table
    if($align=='C')
        $this->TableX=max(($this->w-$TableWidth)/2,0);
    elseif($align=='R')
        $this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
    else
        $this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align='L',$ref='')
{
    //Add a column to the table
    if($field==-1)
        $field=count($this->aCols);
    $this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align,'r'=>$ref);
}

function Table($query,$prop=array())
{
	global $conn;
	if(!empty($conn)){$this->setdb($conn);}
    //Issue query
    $res=$this->db->Execute($query) or die('Error: '.mysql_error()."<BR>Query: $query");
    //Add all columns if none was specified
    if(count($this->aCols)==0)
    {
        //$nb=mysql_num_fields($res);
		$nb=$res->FieldCount();
        for($i=0;$i<$nb;$i++)
            $this->AddCol();
    }
    //Retrieve column names when not specified
    foreach($this->aCols as $i=>$col)
    {
        if($col['c']=='')
        {
            if(is_string($col['f'])){
                $this->aCols[$i]['c']=ucfirst($col['f']);
            }else{
                //$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
                  $fj  = $res->FetchField($col['f']);
			    $this->aCols[$i]['c']=ucfirst($fj->name);
			}
        }
    }
    //Handle properties
    if(!isset($prop['width']))
        $prop['width']=0;
    if($prop['width']==0)
        $prop['width']=$this->w-$this->lMargin-$this->rMargin;
    if(!isset($prop['align']))
        $prop['align']='C';
    if(!isset($prop['padding']))
        $prop['padding']=$this->cMargin;
    $cMargin=$this->cMargin;
    $this->cMargin=$prop['padding'];
    if(!isset($prop['HeaderColor']))
        $prop['HeaderColor']=array();
    $this->HeaderColor=$prop['HeaderColor'];
    if(!isset($prop['color1']))
        $prop['color1']=array();
    if(!isset($prop['color2']))
        $prop['color2']=array();
    $this->RowColors=array($prop['color1'],$prop['color2']);
    //Compute column widths
    $this->CalcWidths($prop['width'],$prop['align']);
    //Print header
    $this->TableHeader();
    //Print rows
    $this->SetFont('uni','',11);
    $this->ColorIndex=0;
    $this->ProcessingTable=true;
	//while($row=mysql_fetch_array($res))
	while($row=$res->FetchRow())
            $this->Row($row);
    $this->ProcessingTable=false;
    $this->cMargin=$cMargin;
    $this->aCols=array();
}
}
class PDF extends PDF_MySQL_Table
{
var $title,$pgname,$cond;
function Header()
{
    //Title
    // $this->Image('./images/logo.jpg',10,5,25,25); 
    // $this->SetTextColor(0,0,0);
    // $this->SetFont('uni','B',26);
    // $this->Ln(8);
    // $this->Cell(0,2,$this->title,0,1,'C');
    // $this->Ln(10);


    // //Ensure table header is output
    // parent::Header();
}
}

//====end class
  $querystr='';
 if (empty($s_date)) $s_date=date("Y-m-d");
 if (empty($e_date)) $e_date=date("Y-m-d");
 //$sql="select * from greserv where hid='$hid'  and v_type!='A' and rd_cidate between '$s_date' and '$e_date' and rd_status in ('Y') order by v_type,rd_cidate,stoke,v_name ";
 $sql="select * from greserv where hid='$hid' and rd_cidate between '$s_date' and '$e_date' and rd_status in ('Y') order by v_type,rd_cidate,stoke,v_name ";
 $rs= &$conn->Execute($sql);
 if( empty($rs)){
    echo $strMeta."<script> alert('greserv 錯誤'); </script> ";
    exit;
 }
		       /*
		       $c_addr=$rs->fields('c_addr');
		       $rd_remark=$rs->fields('rd_remark');
		       $v_birth='';
		       if (!empty($v_idno)) {
		         if ($v_type=='C') {
		           $sqlx="select v_birth from custmaster where v_idno='$v_idno' ";
		           $rsx=$conn->Execute($sqlx);
		           if (!$rsx->EOF) {
		             $v_birth=$rsx->fields('v_birth');
               }
               $rsx->Close();
		         }
           }
           */
           $sqlx="select sum(fee_amt-back_fee) rd_fee from reserfee where prd_no='$prd_no' ";
           $rsx=$conn->Execute($sqlx);
           $rd_fee=0;
           if (!$rsx->EOF) {
             $rd_fee=$rsx->fields('rd_fee');
           }
           $rsx->Close();
/*
           $sql2="select * from agency where hid='$hid' and ag_code='$v_idno' ";
           $rs2= &$conn->Execute($sql2);
           $ag_name=$rs2->fields("ag_name");
*/           
   /******************************************/
//    saymsg("soyalsql = $soyalsql");
/*
  $rs=&$conn->Execute($sql);
  if (!$rs) {
        print ($strMeta."<h3>(HFS50GS).</h3><br>".$conn->ErrorMsg());
        exit;
    }
 $sql="select * from prechkin where res_no = '$prd_no'  group by room_no order by room_no ";
 $rs= &$conn->Execute($sql);
 if( empty($rs)){
    echo $strMeta."<script> alert('prechkin 錯誤'); </script> ";
    exit;
 }
  if ($rs->rowcount()==0) {
        print ($strMeta."<h3>查 無 預 排 房 資 料.</h3><br>");
        exit;
    }
*/
//=======================
//====開啟pdf
//$xylen=array(110.0,155.0);//25.54*6=155
// $xylen=array(215.9,140.0);  // 中一刀
// $pdf=new PDF("P","mm",$xylen);
if (empty($p_size)) $p_size='a4';
$pdf=new PDF("P","mm",$p_size);
//$pdf->SetFontSize(14);
$pdf->AddBig5Font();
$pdf->Open();
$sqlstr="select * from admsetup";
$rsstr=&$conn->Execute($sqlstr);
if ($rsstr->Rowcount()==0) {
	// $pdf->title='admsetup 無公司名稱';
    $hname='admsetup 無公司名稱';
} else {
        // $pdf->title=$rsstr->fields("hname");
        $hname=$rsstr->fields("hname");
}	

	$pdf->AddPage();
	$pdf->AliasNbPages();
	$pdf->SetAutoPageBreak(false,3);
	
	$lwidth=$pdf->w - $pdf->lMargin;
     $marX=18;
     $marY=18;
	while (!$rs->EOF) {
    $rid=$rs->fields("rid");
    $rd_cidate=$rs->fields("rd_cidate");
    $rd_codate=$rs->fields("rd_codate");
    $v_type=$rs->fields("v_type");
    $v_name=$rs->fields("v_name");
    $v_idno=$rs->fields("v_idno");
    $prd_no=$rs->fields("prd_no");
    $c_tel=$rs->fields('c_tel');
    if($c_tel=="null"){$c_tel="";}
    $s_amt=$rs->fields('s_amt');
    $rd_days=$rs->fields('rd_days');
    $rd_room_qty=$rs->fields('rd_room_qty');
    $rd_remark=$rs->fields('rd_remark');
    $m_cidno=$rs->fields('m_cidno');
    $rest_amt=$rs->fields('rest_amt');
    $v_coname="";
    $v_birth="";
           $sqlx="select sum(rd_fee-back_fee) rd_fee from reserfee where prd_no='$prd_no' ";
           $rsx=$conn->Execute($sqlx);
           $rd_fee=0;
           if (!$rsx->EOF) {
             $rd_fee=$rsx->fields('rd_fee');
           }
           $rsx->Close();
           if($v_type=="C"){
            $sqlq="select v_birth,v_coname from custmaster where v_idno='$v_idno'";
            $rsq=$conn->Execute($sqlq);
            if (!$rsq->EOF) {
                $v_birth=$rsq->fields('v_birth');
                $v_coname=$rsq->fields('v_coname');
              }
              $rsq->Close();
           }
           if($v_type=="V"){
            $sqlq="select v_birth,v_coname from vipmaster where v_idno='$v_idno'";
            $rsq=$conn->Execute($sqlq);
            if (!$rsq->EOF) {
                $v_birth=$rsq->fields('v_birth');
                $v_coname=$rsq->fields('v_coname');
              }
              $rsq->Close();
           }
           if($v_type=="S"){
            $sqlq="select m_coname from merch where m_cidno='$v_idno'";
            $rsq=$conn->Execute($sqlq);
            if (!$rsq->EOF) {
                $v_coname=$rsq->fields('m_coname');
                $v_idno="";
              }
              $rsq->Close();
           }
           if($v_type=="A"){
            $sqlq="select ag_name from agency where ag_code='$v_idno'";
            $rsq=$conn->Execute($sqlq);
            if (!$rsq->EOF) {
                $v_coname=$rsq->fields('ag_name');
                $v_idno="";
              }
              $rsq->Close();
           }
           $sqlq="select type_desc,pkgname from grproom a 
           LEFT JOIN roomtype b ON a.room_type=b.room_type
           LEFT JOIN cpackage  c ON a.pkgno=c.pkgno
           where prd_no='$prd_no' order by pkgname desc";
           $rsq=$conn->Execute($sqlq);
           if (!$rsq->EOF) {
               $type_desc=$rsq->fields("type_desc");
               $pkgname=$rsq->fields("pkgname");
           }
           $rsq->Close();

    $sqly="select * from prechkin where res_no='$prd_no' group by room_no";
    $rsy=$conn->Execute($sqly);
    $pre_roomno="";
    while (!$rsy->EOF) {
        $pre_roomno.=$rsy->fields("room_no").",";
        $rsy->MoveNext();
    }
    $pre_roomno=substr($pre_roomno,0,-1);
    $pdf->SetFont('uni','B',26); 
    $pdf->Image('./images/logo.jpg',10,5,25,25);
    $pdf->Cell(150,20,"\n\n".$hname,0,0,'C');
    $pdf->SetFont('uni','B',14);
    $pdf->Cell(40,20,"訂房代號: G".$rid,0,0,'L');
    $pdf->SetFont('uni','B',20);
    $pdf->Ln(20);
    $pdf->Cell(190,20,"GUEST REGISTRATION  旅客登記卡",1,0,'C');
    $pdf->Ln(20);
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(60,5,"GUEST NAM",TL,0,'L');
    $pdf->Cell(60,5,"",T,0,'L');
    $pdf->Cell(70,5,"MOBILE NO",LTR,0,'L');
    $pdf->Ln();
    $pdf->Cell(60,5,"姓名",L,0,'L');
    $pdf->Cell(60,5,"",0,0,'L');
    $pdf->Cell(70,5,"連絡電話",LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',14);
    $pdf->Cell(60,10,$v_name,L,0,'L');
    $pdf->Cell(60,10,"",0,0,'L');
    $pdf->Cell(70,10,$c_tel,LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(60,5,"Arrival",TL,0,'L');
    $pdf->Cell(60,5,"Departure",TL,0,'L');
    $pdf->Cell(70,5,"Passport/ID NO",LTR,0,'L');
    $pdf->Ln();
    $pdf->Cell(60,5,"入住日期",L,0,'L');
    $pdf->Cell(60,5,"退房日期",L,0,'L');
    $pdf->Cell(70,5,"護照/身分證號",LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',14);
    $pdf->Cell(60,10,$rd_cidate,L,0,'L');
    $pdf->Cell(60,10,$rd_codate,L,0,'L');
    $pdf->Cell(70,10,$v_idno,LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(60,5,"NO. of Nigh",TL,0,'L');
    $pdf->Cell(60,5,"Date of Brith",TL,0,'L');
    $pdf->Cell(70,5,"License plate NO.",LTR,0,'L');
    $pdf->Ln();
    $pdf->Cell(60,5,"入住天數",L,0,'L');
    $pdf->Cell(60,5,"出生日期",L,0,'L');
    $pdf->Cell(70,5,"車牌",LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',14);
    $pdf->Cell(60,10,$rd_days,L,0,'L');
    $pdf->Cell(60,10,$v_birth,L,0,'L');
    $pdf->Cell(70,10,"",LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(60,5,"Room Type",TL,0,'L');
    $pdf->Cell(60,5,"NO. of Room",TL,0,'L');
    $pdf->Cell(70,5,"Company",LTR,0,'L');
    $pdf->Ln();
    $pdf->Cell(60,5,"房型",L,0,'L');
    $pdf->Cell(60,5,"間數",L,0,'L');
    $pdf->Cell(70,5,"公司名稱",LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',14);
    $pdf->Cell(60,10,$type_desc,L,0,'L');
    $pdf->Cell(60,10,$rd_room_qty,L,0,'L');
    $pdf->Cell(70,10,$v_coname,LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(60,5,"Room NO.",TL,0,'L');
    $pdf->Cell(60,5,"Room Rate(NT)",TL,0,'L');
    $pdf->Cell(70,5,"Package",LTR,0,'L');
    $pdf->Ln();
    $pdf->Cell(60,5,"房間號碼",L,0,'L');
    $pdf->Cell(60,5,"房價",L,0,'L');
    $pdf->Cell(70,5,"專案",LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',14);
    $pdf->Cell(60,10,$pre_roomno,L,0,'L');
    $pdf->Cell(60,10,"",L,0,'L');//$s_amt
    $pdf->Cell(70,10,$pkgname,LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(120,7,"Breakfast 早餐:",TL,0,'L');
    $pdf->Cell(70,5,"Total Price(NT)",TLR,0,'L');
    $pdf->Ln();
    $pdf->Cell(120,7,"Dinner 晚餐:",L,0,'L');
    $pdf->Cell(70,5,"總房價",LR,0,'L');
    $pdf->Ln();
    $pdf->Cell(120,7,"Add 加購:",L,0,'L');
    $pdf->Cell(70,7,"",LR,0,'L');//$s_amt+$rest_amt
    $pdf->Ln();
    $pdf->Cell(120,7,"Invoice發票:□二聯   □三聯",TL,0,'L');
    $pdf->Cell(70,5,"Deposit",TLR,0,'L');
    $pdf->Ln();
    $pdf->Cell(120,7,"統編:",L,0,'L');//.$m_cidno
    $pdf->Cell(70,5,"已收訂金",LR,0,'L');
    $pdf->Ln();
    $pdf->Cell(120,7,"抬頭:",L,0,'L');
    $pdf->SetFont('uni','B',14);
    $pdf->Cell(70,7,$rd_fee,LR,0,'L');
    $pdf->Ln();
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(190,5,"應收餘額",TLR,0,'L');
    $pdf->Ln();
    $pdf->Cell(190,5,"Balance(NT)",LR,0,'L');
    $pdf->Ln();
    $pdf->Cell(190,10,"",LR,0,'L');//$s_amt+$rest_amt-$rd_fee
    $pdf->Ln();
    $pdf->Cell(190,5,"備註:",TRL,0,'L');
    $pdf->Ln();
    $pdf->Cell(190,15,"",RL,0,'L');
    $pdf->Ln();
    $pdf->MultiCell(190,5,"",RL,'L');
    // $pdf->Ln();
    $pdf->SetFont('uni','B',12);
    $pdf->MultiCell(190,5,"
    【住房注意事項】
    •  全館禁菸，如需吸菸請至本棟建築物外。
    •  不得攜帶寵物入內，導盲犬不在此規範內。
    •  患有傳染性疾病者，請先行告知服務人員。
    •  住宿、休憩中若有任何不適，請立即通知服務人員。
    •  配合政府法令，全館禁止抽菸、賭博和吸毒。
    ",TRL,'L');
    // $pdf->SetFont('uni','B',12);
    // $pdf->Cell(190,6,"【住房注意事項】",TRL,0,'L');
    // $pdf->Ln();
    // $pdf->Cell(190,6,"• 全館禁菸，如需吸菸請至本棟建築物外。",RL,0,'L');
    // $pdf->Ln();
    // $pdf->Cell(190,6,"• 不得攜帶寵物入內，導盲犬不在此規範內。",RL,0,'L');
    // $pdf->Ln();
    // $pdf->Cell(190,6,"• 患有傳染性疾病者，請先行告知服務人員。",RL,0,'L');
    // $pdf->Ln();
    // $pdf->Cell(190,6,"• 住宿、休憩中若有任何不適，請立即通知服務人員。",RL,0,'L');
    // $pdf->Ln();
    // $pdf->Cell(190,6,"• 配合政府法令，全館禁止抽菸、賭博和吸毒。",RL,0,'L');
    // $pdf->Ln();
    $pdf->SetFont('uni','B',10);
    $pdf->Cell(95,5,"Guest Signature貴賓簽名",TL,0,'C');
    $pdf->Cell(95,5,"Clerk櫃台人員",TLR,0,'C');
    $pdf->Ln();
    $pdf->Cell(95,20,"",BL,0,'L');
    $pdf->Cell(95,20,"",BLR,0,'L');
		$rs->MoveNext();
		$irc++;
		if (!$rs->EOF) 
	    $pdf->AddPage();
		
	}
	$rs->Close();
//	$pdf->SetFont('uni','B',11);
//	$pdf->Cell(0,6,">>>共 $rows 筆<<<",0,1,'C');
  $pdf->SetDisplayMode(75);
	$pdf->Output();
?>
