<?php 
include("../glbinc.inc");
include($inc_path."sqlop.php");    
include( "Spreadsheet/Excel/Writer.php");

class XLS_Table extends Spreadsheet_Excel_Writer
{
var $ProcessingTable=false;
var $aCols=array();

var $Headerformat;
var $Rowformat;
var $formatIndex;
var $db = null;//adodb

var $sheet;
var $currentRow=0;
var $shiftCol=0;
function setdb(&$conn)
{
	    if ($conn){
               $this->db = $conn;
          /*選擇存取的table files*/
        } else {
           if (!$conn) {
            die('連線尚未設定!');
           } else {
            die ('找不到資料庫!');
           }
	    }
}
function Headers()
{
    //Print the table header if necessary
    if($this->ProcessingTable)
        $this->TableHeader();
}

function TableHeader()
{
    if(is_array($this->Headerformat) && count($this->Headerformat)>0){
    	//global $rFormat;
    	$rFormat =& $this->addFormat();
    	if(!empty($this->Headerformat['Color'])) 
        $rFormat->setColor($this->Headerformat['Color']);
        if(!empty($this->Headerformat['FgColor']))
        $rFormat->setFgColor($this->Headerformat['FgColor']);
    }
    $this->sheet->WriteRow($this->currentRow,$this->shiftCol,$this->aCols['c'],$rFormat); 
	$this->currentRow++;
}

function Row($data)
{
    $ci=$this->formatIndex;
    if(is_array($this->Rowformat[$ci]) && count($this->Rowformat[$ci])>0 ){
    	//global $rFormat;
    	$rFormat =& $this->addFormat();
    	if(!empty($this->Rowformat[$ci]['Color']))  
        $rFormat->setColor($this->Rowformat[$ci]['Color']);
        if(!empty($this->Rowformat[$ci]['FgColor']))
        $rFormat->setFgColor($this->Rowformat[$ci]['FgColor']);
        $rFormat->setNumFormat(0x31);//0x31    @
//        $rFormat->setNumFormat("'");//0x31    @
    } else {
    	$rFormat =& $this->addFormat();
      $rFormat->setNumFormat(0x31);//0x31    @
    }
    $insdatstr=array();
    foreach($this->aCols['f'] as $col) {
//      if (($col=='v_tel1') or ($col=='v_tel2'))
//        $insdatstr[]=" ".$data[$col];
//        $insdatstr[]=$data[$col];
//      else
        $insdatstr[]=$data[$col];
      }
    $this->sheet->WriteRow($this->currentRow,$this->shiftCol,$insdatstr,$rFormat); 
	$this->currentRow++;
	
    $this->formatIndex=1-$ci;
}

function AddCol($field=-1,$caption='',$align='L')
{
    //Add a column to the table
    if($field==-1)$field=count($this->aCols['c']);
    //$this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align,'r'=>$refer,'m'=>$Multi);
     $this->aCols['c'][]=$caption; 
     $this->aCols['f'][]=$field;
     $this->aCols['a'][]=$align;
}

function Table($prop=array(),$show_header=true)//$query,
{
    //Retrieve column names when not specified
    foreach($this->aCols['c'] as $i=>$col)
    {
        if($col=='')
        {
            if(is_string($this->aCols['f'][$i])){
                $this->aCols['c'][$i]=ucfirst($this->aCols['f'][$i]);
            }
        }
    }

    //Handle properties
    if(isset($prop['OriginPoint']) && is_array($prop['OriginPoint']) 
    && count($prop['OriginPoint'])==2 ){
    	list($this->currentRow,$this->shiftCol)=$prop['OriginPoint'];
    }
        $prop['Headerformat']=array();
    if(!isset($prop['Headerformat']))
        $prop['Headerformat']=array();
    $this->Headerformat=$prop['Headerformat'];
    if(!isset($prop['rformat1']))
        $prop['rformat1']=array();
    if(!isset($prop['rformat2']))
        $prop['rformat2']=array();
    if(!isset($prop['rformat3']))
        $prop['rformat3']=array();
    $this->Rowformat=array($prop['rformat1'],$prop['rformat2'],$prop['rformat3']);
    //Compute column widths

    //Print header
	if($show_header)
      $this->TableHeader();
 
    $this->formatIndex=0;
 $this->ProcessingTable=true;
 //handle row[]
 //must end by close_Table()
}
//===thomas
//==usage:for excute sql external from this class
function colse_Table()
{
	//while($row=mysql_fetch_array($res))
	//while($row=$res->FetchRow())$this->Row($row);

    $this->ProcessingTable=false;
    $this->aCols=array();//清空 欄位設定
//=========
}
}
set_time_limit(0);
$table_name='invoice';
    $sql="select * from $table_name  "; /* for browse */
    $Tsql=" select * from $table_name "; /* for query */
    $trs=&$conn->SelectLimit($Tsql,1);
    $querystr=getquerystr($trs,$sel_method);
//           				if (!empty($month)){
//				    if(!empty($querystr)){$sel_methstr=$sel_method;}else{$sel_methstr="";}
//				    $querystr.=$sel_methstr." (DATE_FORMAT(v_birth, '%m') ='$month' or DATE_FORMAT(specdate,'%m')= '$month') ";
//						}
    if (empty($querystr)) {
       $querystr = "(1=1)";
       $no_qry="Y";
    }
    if(!empty($bdate) && !empty($edate) && $bdate <= $edate){
        $querystr .=empty($querystr)? "(inv_date between '$bdate' and '$edate') ":$sel_method." (inv_date between '$bdate' and '$edate') ";
    }
    if (empty($querystr)) {
        print ("$strMeta<h3>請輸入查詢條件.</h3><br>");
        exit;
    }

   /*Join 兩個以上table時要處理 單一table不必 */
/*
    $ncols=$trs->fieldcount();
    for ($i=0;$i<$ncols;$i++){
      $field_array=$trs->fetchfield($i);
      $field_name=$field_array->name;
      $querystr =ereg_replace(" $field_name"," a.$field_name",$querystr);
      }
*/
   //$querystr=stripslashes($querystr);
   /******************************************/
//                  saymsg("query = $querystr");
    //modfiy by ming 20230302, 要全部顯示
    //  $S_where = " where  $querystr and inv_status!='1' order by inv_type,inv_code,inv_seq";
    $S_where = " where  $querystr order by inv_type,inv_code,inv_seq";
     //$S_where = " where  $querystr order by rid,inv_code,inv_seq";
     //$S_where=stripslashes($S_where);
     $sql.=$S_where; /*browse mode */
     $rs=$conn->Execute($sql);
     if (!$rs) {
        print ("$strMeta<h3>查 無 資 料.</h3><br>");
        exit;
     }
     $rows=$rs->Rowcount();
     if ($rows==0) {
        print ("$strMeta<h3>查 無 資 料.</h3><br>");
        exit;
     }
     //echo "$sql<br>";
     //exit;
 
     $sqlglo = "select * from admsetup ";
     $rsglo = $conn->Execute($sqlglo);
     if (empty($rsglo)) {
       echo $strMeta . "錯誤 admsetup " . basename(__FILE__) . " :" . $conn->ErrorMsg();
       $conn->RollbackTrans();
       exit;
     }
     $inv_coname = $rsglo->fields("inv_coname");
     $inv_coid = $rsglo->fields("inv_coid");
     
     $filename='invoice'.date('YmdHis').'.xls';
   $xls = new XLS_Table();//Spreadsheet_Excel_Writer(); 
   $xls->setVersion(8); 
   $xls->send("$filename"); 

// Add a worksheet to the file, returning an object to add data to 
$sheet =& $xls->addWorksheet('invoice_List'); 
$sheet->setColumn(0,0,12);
$sheet->setColumn(0,1,10);
$sheet->setColumn(0,2,8);
$sheet->setColumn(0,3,8);
$sheet->setColumn(0,4,10);//====發票日期
$sheet->setColumn(0,5,12);
$sheet->setColumn(0,6,18);
$sheet->setColumn(0,7,12);
$sheet->setColumn(0,8,18);
$sheet->setColumn(0,9,8);
$sheet->setColumn(0,10,10);
$sheet->setColumn(0,11,10);
$sheet->setColumn(0,12,10);
$sheet->setColumn(0,13,10);
$sheet->setColumn(0,14,10);
$sheet->freezePanes(array(1, 0));

$xls->sheet=&$sheet;
$xls->sheet->setInputEncoding('utf-8'); 
//===================================================================================

$xls->AddCol('inv_no',"發票號碼",'C');//
$xls->AddCol('brf1',"註記欄(不轉入進銷項媒體申報檔)",'C');
$xls->AddCol('inv_type','格式代號','C');
$xls->AddCol('inv_status','發票狀態','C');
$xls->AddCol('inv_date','發票日期','C');
$xls->AddCol('inv_busino','買方統一編號','C');
$xls->AddCol('cust_name','買方名稱','C');
$xls->AddCol('inv_coid','賣方統一編號','C');
$xls->AddCol('inv_coname','賣方名稱','C');
$xls->AddCol('brf2',"寄送日期",'C');
$xls->AddCol('netamt','銷售額合計','C');
$xls->AddCol('','零稅銷售額','C');
$xls->AddCol('','免稅銷售額','C');
$xls->AddCol('taxamt','營業稅','C');
$xls->AddCol('salamt','總計','C');
$xls->AddCol('brf3','課稅別','C');
$xls->AddCol('brf4','免稅銷售額','C');
/*樣式
$prop=array(
             'OriginPoint'=>array(0,0),
             'Headerformat'=>array('Color'=>'white',
                                   'FgColor'=>'grey'),
             'rformat1'=>array('Color'=>'white',
                                'FgColor'=>'grey'),
            'rformat2'=>array('Color'=>'yellow',
                              'FgColor'=>'grey')
            );

$prop=array(
            'rformat1'=>array('Color'=>'navy'),
            'rformat2'=>array('FgColor'=>'grey')
    );
*/
//$xls->Header();
$xls->Table($prop);//,$prop
//===========================================
  $arr=array();
  $rw=1; $rc=0;
     if ($rs)
        while (!$rs->EOF) {
            /*
           if($rs->fields('inv_status')=='1') { 
               $rs->movenext();
               continue;
           }*/

           $rc=0;
           $inv_type=$rs->fields('inv_type');
           $inv_status=$rs->fields('inv_status');
           $inv_date=$rs->fields('inv_date');
           $salamt=$rs->fields('inv_money');
           $taxamt=$rs->fields('inv_tax');
           $cust_name=$rs->fields('cust_name');
           if (empty($cust_name)) { $cust_name='0000'; }
           $inv_busino=$rs->fields('inv_busino');
           if (empty($inv_busino)) { 
               $inv_busino='00000000';
               $taxamt=0;
           }
           $netamt=$salamt - $taxamt;

           switch ($inv_type) {
            case '31': $v_inv_type_desc='31'; $pagelen=50; break;
            case '32': $v_inv_type_desc='32'; $pagelen=50; break;
            case '07':
            case '35': $v_inv_type_desc='35'; $pagelen=250; break;
      //      case '36': $v_inv_type_desc='二聯式手開'; break;
      //      case '37': $v_inv_type_desc='三聯式手開'; break;
            default : $v_inv_type_desc=''; break;
          }
          $inv_status=$rs->fields('inv_status');
          switch ($inv_status) {
            case '1': $v_inv_status_desc=''; break;
            case '2': $v_inv_status_desc='使用中'; break;
            case '3': $v_inv_status_desc='開立'; break;
      //      case '3': $v_inv_status_desc='已使用'; break;
            case '4': $v_inv_status_desc='作廢'; break;
            default: $v_inv_status_desc=''; break;
          }
//           $arr['inv_no']=$rs->fields('inv_code').$rs->fields('inv_seq');
//           $arr['inv_year']=$rs->fields('inv_year');
//           $arr['inv_month']=sprintf('%02d',$rs->fields('inv_month'));
           $inv_no=$rs->fields('inv_code').$rs->fields('inv_seq');
           $xls->sheet->writeString($rw,$rc++,$inv_no);
           $xls->sheet->writeString($rw,$rc++,''); //===註記欄(不轉入進銷項媒體申報檔)
           $xls->sheet->writeString($rw,$rc++,$v_inv_type_desc);
           $xls->sheet->writeString($rw,$rc++,$v_inv_status_desc);
           $xls->sheet->writeString($rw,$rc++,$inv_date);
           $xls->sheet->writeString($rw,$rc++,$inv_busino);
           $xls->sheet->writeString($rw,$rc++,$cust_name);
           $xls->sheet->writeString($rw,$rc++,$inv_coid);
           $xls->sheet->writeString($rw,$rc++,$inv_coname);
           $xls->sheet->writeString($rw,$rc++,''); //===寄送日期
           $xls->sheet->writeNumber($rw,$rc++,$netamt);
           $xls->sheet->writeNumber($rw,$rc++,0);//modfiy by ming 20200324
           $xls->sheet->writeNumber($rw,$rc++,0);//modfiy by ming 20200324
           $xls->sheet->writeNumber($rw,$rc++,$taxamt);
           $xls->sheet->writeNumber($rw,$rc++,$salamt);
           $xls->sheet->writeString($rw,$rc++,'應稅'); //===課稅別
           $xls->sheet->writeNumber($rw,$rc++,0); //===免稅銷售額

           $rw++;
	         //$xls->Row($arr);
	         $rs->Movenext();
        } 
//echo $html;
//===========================================
$xls->colse_Table();
$xls->close(); 
?>
