<?php 
include("../glbinc.inc");

include($inc_path."fpdf/chinese.php");
//include("/home/www/WebHotel/Kindness/Front/opendb.inc");
//include("/home/www/WebHotel/Kindness/Front/table.class.php");

//==========pdf class


class PDF_MySQL_Table extends PDF_Chinese
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;
var $db = null;//adodb
function setdb(&$conn)
{
	    if ($conn){
               $this->db = $conn;
          /*選擇存取的table files*/
        } else {
           if (!$conn) {
            die('連線尚未設定!');
           } else {
            die ('找不到資料庫!');
           }
	    }
}
function Header()
{
    //Print the table header if necessary
    if($this->ProcessingTable)
        $this->TableHeader();
}

function TableHeader()
{
    $this->SetFont('Big5','B',12);
    $this->SetX($this->TableX);
    $fill=!empty($this->HeaderColor);
    if($fill)
        $this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
    foreach($this->aCols as $col)
        $this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
    $this->Ln();
}

function Row($data)
{
    $this->SetX($this->TableX);
    $ci=$this->ColorIndex;
    $fill=!empty($this->RowColors[$ci]);
    if($fill)
        $this->SetFillColor($this->RowColors[$ci][0],$this->RowColors[$ci][1],$this->RowColors[$ci][2]);
    foreach($this->aCols as $col)
        $this->Cell($col['w'],5,$data[$col['f']],1,0,$col['a'],$fill);
    $this->Ln();
    $this->ColorIndex=1-$ci;
}

function CalcWidths($width,$align)
{
    //Compute the widths of the columns
    $TableWidth=0;
    foreach($this->aCols as $i=>$col)
    {
        $w=$col['w'];
        if($w==-1)
            $w=$width/count($this->aCols);
        elseif(substr($w,-1)=='%')
            $w=$w/100*$width;
        $this->aCols[$i]['w']=$w;
        $TableWidth+=$w;
    }
    //Compute the abscissa of the table
    if($align=='C')
        $this->TableX=max(($this->w-$TableWidth)/2,0);
    elseif($align=='R')
        $this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
    else
        $this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align='L')
{
    //Add a column to the table
    if($field==-1)
        $field=count($this->aCols);
    $this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align);
}

function Table($query,$prop=array())
{
	global $conn;
	if(!empty($conn)){$this->setdb($conn);}
    //Issue query
    $res=$this->db->Execute($query) or die('Error: '.mysql_error()."<BR>Query: $query");
    //Add all columns if none was specified
    if(count($this->aCols)==0)
    {
        //$nb=mysql_num_fields($res);
		$nb=$res->FieldCount();
        for($i=0;$i<$nb;$i++)
            $this->AddCol();
    }
    //Retrieve column names when not specified
    foreach($this->aCols as $i=>$col)
    {
        if($col['c']=='')
        {
            if(is_string($col['f'])){
                $this->aCols[$i]['c']=ucfirst($col['f']);
            }else{
                //$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
                  $fj  = $res->FetchField($col['f']);
			    $this->aCols[$i]['c']=ucfirst($fj->name);
			}
        }
    }
    //Handle properties
    if(!isset($prop['width']))
        $prop['width']=0;
    if($prop['width']==0)
        $prop['width']=$this->w-$this->lMargin-$this->rMargin;
    if(!isset($prop['align']))
        $prop['align']='C';
    if(!isset($prop['padding']))
        $prop['padding']=$this->cMargin;
    $cMargin=$this->cMargin;
    $this->cMargin=$prop['padding'];
    if(!isset($prop['HeaderColor']))
        $prop['HeaderColor']=array();
    $this->HeaderColor=$prop['HeaderColor'];
    if(!isset($prop['color1']))
        $prop['color1']=array();
    if(!isset($prop['color2']))
        $prop['color2']=array();
    $this->RowColors=array($prop['color1'],$prop['color2']);
    //Compute column widths
    $this->CalcWidths($prop['width'],$prop['align']);
    //Print header
    $this->TableHeader();
    //Print rows
    $this->SetFont('Big5','',11);
    $this->ColorIndex=0;
    $this->ProcessingTable=true;
	//while($row=mysql_fetch_array($res))
	while($row=$res->FetchRow())
            $this->Row($row);
    $this->ProcessingTable=false;
    $this->cMargin=$cMargin;
    $this->aCols=array();
}
}
class PDF extends PDF_MySQL_Table
{
var $title, $pgname,$cond;
function Header()
{
    //Title
	$this->setX($this->tableX);
    $this->SetFont('Big5','B',14);
    $this->Cell(0,6,$this->title,0,1,'C');
    $this->SetFont('Big5','B',12); 
    //$this->SetFont('Arial','',18);
	$this->setX($this->lMargin);
	$ptime='印表時間: '.date("Y/m/d H:i");
	$this->Cell(10,6,$ptime,0,0,'L');
	$this->setX($this->tableX);
    $this->Cell(0,6,$this->pgname,0,0,'C');
	$this->setX($this->rMargin-50);
	$this->Cell(0,6,'頁次: '.$this->PageNo(),0,0,'L');
    $this->Ln();
	$this->Cell(10,6,$this->cond,0,0,'L');
    $this->Ln();
    //Ensure table header is output
    parent::Header();
}
}

//====end class

  //======  create table
  $sqltmp="CREATE  Table IF NOT EXISTS T_tel (room_no char(10),roomna char(10),citycnt integer,";
  $sqltmp.="cityamt integer,locnt integer, loamt integer, nacnt integer, naamt integer,";
  $sqltmp.="mocnt integer, moamt integer,bbccnt integer,bbcamt integer, samt INTEGER)";
  $rstmp=&$conn->Execute($sqltmp);
  //===== delete data
  $sqldel="delete from T_tel";
  $rsdel=&$conn->Execute($sqldel);
  $querystr="";
  if ($roomyn!='0') { $querystr.=" roomyn='$roomyn' and "; }
  if (empty($begroom_no)) {$begroom_no='0';}
  if (empty($endroom_no)) {$endroom_no='z';}
  $querystr.=" room_no between '$begroom_no' and '$endroom_no' ";
  $sqloffice="select * from teloffice where ";
  $sqloffice.=$querystr;
  $sqloffice.=" order by room_no";
  $rsoffice=&$conn->Execute($sqloffice);
  //日期區間
  $querystr="";
  if (empty($begdt)) { $begdt='0000-00-00';}
  if (empty($enddt)) { $enddt='9999-12-31';}
  if ($beghm=='') { $beghm='00:00';} else {$beghm=substr($beghm,0,2).':'.substr($beghm,2,2);}
  if ($endhm=='') { $endhm='23:59';} else {$endhm=substr($endhm,0,2).':'.substr($endhm,2,2);}
  $begdttm=$begdt.' '.$beghm.':00';
  $enddttm=$enddt.' '.$endhm.':59';
// saymsg("begdttm=$begdttm enddttm=$enddttm");
  $querystr.= " ".$sel_method."  ( begtm between '$begdttm' and '$enddttm' )  ";
  while (!$rsoffice->EOF) {
	  $citycnt=0; $cityamt=0;
	  $locnt=0; $loamt=0;
	  $nacnt=0; $naamt=0;
	  $mocnt=0; $moamt=0;
	  $bbccnt=0; $bbcamt=0;
	  $room_no=$rsoffice->fields("room_no");
	  //saymsg("room_no=$room_no");
	  $roomna=$rsoffice->fields("roomna");
	  $roomna=quotemeta($roomna);

	  $sqltxn ="select distinct room_no,kndno,count(*) cnt,sum(feeamt) samt";
	  $sqltxn.=" from teltxn ";
//	  $sqltxn.=" where roomyn='1' and room_no='".$room_no."' ";
	  $sqltxn.=" where room_no='".$room_no."' ";
	  $sqltxn.=$querystr.' and feeamt<>0 ';
	  $sqltxn.=" group by room_no,kndno";
	  $sqltxn.=" order by room_no";
	  $rstxn=&$conn->Execute($sqltxn);
	  while (!$rstxn->EOF) {
		  if ($rstxn->fields("kndno")=='1') {
			  $citycnt=$rstxn->fields("cnt");
			  $cityamt=$rstxn->fields("samt");
		  }
		  if ($rstxn->fields("kndno")=='2') {
			  $locnt=$rstxn->fields("cnt");
			  $loamt=$rstxn->fields("samt");
		  }
		  if ($rstxn->fields("kndno")=='3') {
			  $nacnt=$rstxn->fields("cnt");
			  $naamt=$rstxn->fields("samt");
		  }
		  if ($rstxn->fields("kndno")=='4') {
			  $mocnt=$rstxn->fields("cnt");
			  $moamt=$rstxn->fields("samt");
		  }
		  if ($rstxn->fields("kndno")=='5') {
			  $bbccnt=$rstxn->fields("cnt");
			  $bbcamt=$rstxn->fields("samt");
		  }
		  $rstxn->MoveNext();
	  } 
	  $samt=$cityamt+$loamt+$naamt+$moamt+$bbcamt;
      $sqlins="insert into T_tel (room_no,roomna,citycnt,cityamt,locnt,loamt,nacnt,naamt,";
	  $sqlins.="mocnt,moamt,bbccnt,bbcamt,samt) values (";
	  $sqlins.="'$room_no','$roomna',";
	  $sqlins.="'$citycnt','$cityamt','$locnt','$loamt','$nacnt','$naamt','$mocnt',";
	  $sqlins.="'$moamt','$bbccnt','$bbcamt','$samt')";
	  $rsins=&$conn->Execute($sqlins);
	  //saymsg("sqlins=$sqlins");
	  $rstxn->Close();
	  $rsoffice->MoveNext();
  }
  $rsoffice->Close();
  $querystr='';
  $sql ="select * from T_tel  order by room_no";
  $Tsql="select * from T_tel  order by room_no";/* for query */
  $trs=&$conn->SelectLimit($Tsql,1);
  //$querystr=getquerystr($trs,$sel_method);
  /*
  if (empty($begroom_no)) {$begroom_no='0';}
  if (empty($endroom_no)) {$endroom_no='z';}
  $querystr.=" ".$sel_method." (room_no between '$begroom_no' and '$endroom_no') ";

  //日期區間
  if (empty($begdt)) { $begdt='0000-00-00';}
  if (empty($enddt)) { $enddt='9999-12-31';}
  if ($beghm=='') { $beghm='00:00';} else {$beghm=substr($beghm,0,2).':'.substr($beghm,2,2);}
  if ($endhm=='') { $endhm='23:59';} else {$endhm=substr($endhm,0,2).':'.substr($endhm,2,2);}
  $begdttm=$begdt.' '.$beghm.':00';
  $enddttm=$enddt.' '.$endhm.':59';
  $querystr.= " ".$sel_method."  ( begtm between '$begdttm' and '$enddttm' )  ";
  $sql.=$querystr." order by begtm,room_no ";	*/
   /******************************************/
  /*
  $rs=&$conn->Execute($sql);
  if (!$rs) {
        print ("<h3>查 無 資 料.</h3><br>");
        exit;
    }

  //$rows=$rs->Rowcount();
  */
  $sqlsum="select sum(citycnt) scitycnt,sum(cityamt) scityamt,sum(locnt) slocnt,sum(loamt) sloamt,";
  $sqlsum.="sum(nacnt) snacnt,sum(naamt) snaamt,sum(mocnt) smocnt,sum(moamt) smoamt,sum(bbccnt) sbbccnt,sum(bbcamt) sbbcamt,sum(samt) ssamt";
  $sqlsum.=" from T_tel ";
  $sqlsum.=" where 1=1 ";
  $rssum=&$conn->Execute($sqlsum);
  $scitycnt=$rssum->fields("scitycnt");
  $scityamt=$rssum->fields("scityamt");
  $slocnt=$rssum->fields("slocnt");
  $sloamt=$rssum->fields("sloamt");
  $snacnt=$rssum->fields("snacnt");
  $snaamt=$rssum->fields("snaamt");
  $smocnt=$rssum->fields("smocnt");
  $smoamt=$rssum->fields("smoamt");
  $sbbccnt=$rssum->fields("sbbccnt");
  $sbbcamt=$rssum->fields("sbbcamt");
  $totamt=$rssum->fields("ssamt");
  $rssum->Close();
//====開啟pdf
//$xylen=array(110.0,155.0);//25.54*6=155
if (empty($p_size)) $p_size='a4';
$pdf=new PDF("P","mm",$p_size);
//$pdf->SetFontSize(14);
$pdf->AddBig5Font();
$pdf->Open();
$sqlstr="select * from admsetup";
$rsstr=&$conn->Execute($sqlstr);
if ($rsstr->Rowcount()==0) {
	$pdf->title='admsetup 無公司名稱';
} else {
        $pdf->title=$rsstr->fields("hname");
}	
if ($roomyn=='0') { $extna='全部'; }
if ($roomyn=='1') { $extna='辦公室'; }
if ($roomyn=='2') { $extna='房間'; }
$pdf->pgname='<<電話分機日報表>>';
$pdf->cond ='列印條件:分機號碼['.$begroom_no.']~['.$endroom_no.']';
$pdf->cond.=' 日期起迄['.$begdttm.']~['.$enddttm.']';
$pdf->cond.=' 分機類別['.$extna.']';

$pdf->AddPage();
//Second table: specify 3 columns

$pdf->AddCol('room_no',10,'分機','L');
$pdf->AddCol('roomna',20,'使用單位','L');
$pdf->AddCol('citycnt',10,'市內','R');
$pdf->AddCol('cityamt',14,'金額','R');
$pdf->AddCol('locnt',10,'長途','R');
$pdf->AddCol('loamt',14,'金額','R');
$pdf->AddCol('nacnt',10,'國際','R');
$pdf->AddCol('naamt',14,'金額','R');
$pdf->AddCol('mocnt',10,'行動','R');
$pdf->AddCol('moamt',14,'金額','R');
$pdf->AddCol('bbccnt',15,'呼叫器','R');
$pdf->AddCol('bbcamt',14,'金額','R');
$pdf->AddCol('samt',15,'小計','R');
$pdf->Table("$sql");//,$prop
$pdf->SetFont('Big5','B',12); 
//$pdf->Ln();
        //$this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
//    $this->SetX($this->TableX);
if ($roomyn=='0') { $sumna='總計--->'; }
if ($roomyn=='1') { $sumna='辦公室總計--->'; }
if ($roomyn=='2') { $sumna='房間總計--->'; }
$pdf->SetX(20);
$pdf->Cell(30,6,$sumna,0,0,'L');
$pdf->Cell(10,6,$scitycnt,0,0,'R');
$pdf->Cell(14,6,$scityamt,0,0,'R');
$pdf->Cell(10,6,$slocnt,0,0,'R');
$pdf->Cell(14,6,$sloamt,0,0,'R');
$pdf->Cell(10,6,$snacnt,0,0,'R');
$pdf->Cell(14,6,$snaamt,0,0,'R');
$pdf->Cell(10,6,$smocnt,0,0,'R');
$pdf->Cell(14,6,$smoamt,0,0,'R');
$pdf->Cell(15,6,$sbbccnt,0,0,'R');
$pdf->Cell(14,6,$sbbcamt,0,0,'R');
$pdf->Cell(14,6,$totamt,0,0,'R');
$pdf->Ln();
$pdf->Cell(0,6,">>共 $rows 筆<<",0,1,'C');
$pdf->Output();
?>