//   其他的配套
//   keybind(acsii,action,mode,muit)
//   acsii = keyCode
//   action = script action
//   mode = new / before / after | default = new
//   muit = true / false
//   keybind(32,"alert('press space bar')","before",false);
//
//   keybindup(acsii,action,mode)
//   acsii = keyCode
//   action = script action
//   mode = new / before / after | default = new
//   keybindup(32,"alert('space bar up')","after");

var keyfps = 50;		// 預設的重複執行微秒
var clock;			// 用於 setInterval 的變量
ssc_commandrate = new Array();
ssc_key = new Array(223);
//------------------------------------------------鍵的功能
function key_class() {
 this.name	=	"NONE";	// 鍵名
 this.action	=	"NONE";	// 寫入的執行指令 keydown
 this.action2	=	"NONE";	// 寫入的執行指令 keyup
 this.muit	=	false;	// 啟動重複執行
 this.keystat	=	false;	// 鍵的狀態
 return this;
}
//------------------------------------------------重複頻率執行
function ssc_repeataction(){
 if(ssc_commandrate.length!=0)
	for(i=0; i<ssc_commandrate.length; i++){
		if(ssc_key[ssc_commandrate[i]].keystat==true)
			eval(ssc_key[ssc_commandrate[i]].action);
		else
			ssc_commandrate.splice(i--,1);
	}
}

clock = setInterval("ssc_repeataction(ssc_commandrate)",keyfps);
//------------------------------------------------開始設定
for(i=0; i<=222; i++) ssc_key[i] = new key_class();
ssc_key[8].name = "Back Space";
ssc_key[9].name = "Tab";
ssc_key[12].name = "Center";
ssc_key[13].name = "Enter";
ssc_key[16].name = "Shift";//***Function key
ssc_key[17].name = "Ctrl";//***Function key
ssc_key[18].name = "Alt";//***Function key
ssc_key[19].name = "Pause";
ssc_key[20].name = "Caps Lock";
ssc_key[27].name = "Esc";
ssc_key[32].name = "Space Bar";
ssc_key[33].name = "Page Up";
ssc_key[34].name = "Page Down";
ssc_key[35].name = "End";
ssc_key[36].name = "Home";
ssc_key[37].name = "Arrow Left";
ssc_key[38].name = "Arrow Up";
ssc_key[39].name = "Arrow Right";
ssc_key[40].name = "Arrow Down";
ssc_key[44].name = "Print Screen"; //***Function key
ssc_key[45].name = "Insert";
ssc_key[46].name = "Delete";
for (i=48; i<=57; i++)
	ssc_key[i].name = String.fromCharCode(i);
//英文大寫
for (i=65; i<=90; i++)
	ssc_key[i].name = String.fromCharCode(i);
ssc_key[91].name = "Start Menu - L"; //***Function key
ssc_key[92].name = "Start Menu - R"; //***Function key
ssc_key[93].name = "Menu"; //***Function key
ssc_key[96].name = "Numpan 0";
ssc_key[97].name = "Numpan 1";
ssc_key[98].name = "Numpan 2";
ssc_key[99].name = "Numpan 3";
ssc_key[100].name = "Numpan 4";
ssc_key[101].name = "Numpan 5";
ssc_key[102].name = "Numpan 6";
ssc_key[103].name = "Numpan 7";
ssc_key[104].name = "Numpan 8";
ssc_key[105].name = "Numpan 9";
ssc_key[106].name = "Numpan *";
ssc_key[107].name = "Numpan +";
ssc_key[109].name = "Numpan -";
ssc_key[110].name = "Numpan .";
ssc_key[111].name = "Numpan /";
//功能鍵
for (i=112; i<=123; i++)
	ssc_key[i].name = "F"+(i-111);
ssc_key[144].name = "Num Lock";
ssc_key[145].name = "Scroll Lock";
ssc_key[186].name = "&#59;";
ssc_key[187].name = "&#61;";
ssc_key[188].name = "&#44;";
ssc_key[189].name = "&#45;";
ssc_key[190].name = "&#46;";
ssc_key[191].name = "&#47;";
ssc_key[192].name = "&#96;";
ssc_key[219].name = "&#91;";
ssc_key[220].name = "&#92;";
ssc_key[221].name = "&#93;";
ssc_key[222].name = "&#39;";

//----------------------------------------------------------設定完畢

function ssc_keydown(e) {
	if (ssc_key[e].action != "NONE" && ssc_key[e].keystat == false){
		eval(ssc_key[e].action);
		if (ssc_key[e].muit == true){
			ssc_commandrate[ssc_commandrate.length] = e;
		}
	}
	ssc_key[e].keystat = true;
}

function ssc_keyup(e) {
	if (ssc_key[e].action2 != "NONE" && ssc_key[e].keystat == true){
		eval(ssc_key[e].action2);
	}
	ssc_key[e].keystat = false;
}

function key_check(acsii){
	if (acsii >= 0 && acsii <= 222) {
		return acsii;
	} else {
	 for (var i=0; i<=222; i++) {
		if (ssc_key[i].name.toLowerCase() == acsii.toLowerCase()){
			return i;
			i = 223;
		}
	 }
	}
}

function keybind(acsii,action,mode,muit){
	acsii = key_check(acsii);
	switch (arguments.length){
	case 4:
	ssc_key[acsii].muit = (muit)?true:false;
	case 3:
	if ('before' == mode.toLowerCase())	action = action +";"+ ssc_key[acsii].action;
	else if ('after' == mode.toLowerCase())	action = ssc_key[acsii].action +";"+ action;
	default:
	ssc_key[acsii].action = action;
	break;
	}
}

function keybindup(acsii2,action2,mode2){
	acsii = key_check(acsii2);
	switch (arguments.length){
	case 3:
	if ('before' == mode2.toLowerCase())	action2 = action2 +";"+ ssc_key[acsii].action2;
	else if ('after' == mode2.toLowerCase()) action2 = ssc_key[acsii].action2 +";"+ action2;
	default:
	ssc_key[acsii].action2 = action2;
	break;
	}
}
document.onkeyup=new Function("ssc_keyup(window.event.keyCode);");
document.onkeydown=new Function("ssc_keydown(window.event.keyCode); window.event.returnValue = false;");