# MySQL-Front 3.1  (Build 9.0)


CREATE TABLE `roomtype` (
  `rid` int(11) NOT NULL auto_increment,
  `hid` char(5) NOT NULL default '',
  `room_type` char(2) NOT NULL default '',
  `type_desc` char(30) NOT NULL default '',
  `totle_room` int(11) NOT NULL default '0',
  `by_order_qty` int(11) NOT NULL default '0',
  `room_price` int(11) NOT NULL default '0',
  `last_m_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_m_user` char(12) NOT NULL default '',
  `r_price` int(11) default NULL,
  `re_price` int(11) default NULL,
  PRIMARY KEY  (`rid`),
  UNIQUE KEY `rtype_idx` (`hid`,`room_type`)
) TYPE=InnoDB CHARSET=latin1;

INSERT INTO `roomtype` VALUES (4,'001','SD','經濟型單人房',6,6,2000,'2004-01-13 16:02:19','james',600,200);
INSERT INTO `roomtype` VALUES (5,'001','SC','標準型單人房',8,8,2200,'2003-05-02 00:00:00','STANLEY',NULL,NULL);
INSERT INTO `roomtype` VALUES (6,'001','SB','商務型單人房',7,7,2400,'2004-04-30 10:46:08','james',800,200);
INSERT INTO `roomtype` VALUES (8,'001','TB','商務型雙人房',2,2,3000,'2002-11-18 00:00:00','stanley',NULL,NULL);
INSERT INTO `roomtype` VALUES (9,'001','TA','豪華型雙人房',1,1,3300,'2002-11-18 00:00:00','stanley',NULL,NULL);
INSERT INTO `roomtype` VALUES (10,'001','UC','商務型套房',2,2,3000,'2004-01-13 08:47:30','james',600,200);
INSERT INTO `roomtype` VALUES (11,'001','UA','永康劍橋大套房',1,1,8000,'2002-11-18 00:00:00','stanley',NULL,NULL);

