<?php 
include("glbinc.inc");
include($inc_path."fpdf/fpdf_js.php");
//include("/home/www/WebHotel/Kindness/Front/opendb.inc");
//include("/home/www/WebHotel/Kindness/Front/table.class.php");

//==========pdf class
//die('test');
class PDF extends PDF_Javascript
{
var $B;
var $I;
var $U;
var $HREF;

var $col=0;
#設col邊界,多行設定
function SetCol($col)
{
    //Move position to a column
    $this->col=$col;
    $x=20+$col*100;
    $this->SetLeftMargin($x);
    $this->SetX($x);
}

function PageBreak($ptop)
{
    if($this->col<1)
    {
        //Go to next column 第2欄才跳頁
        $this->SetCol($this->col+1);
        $this->SetY($ptop);//1 row是5 units
        return false;
    }
    else
    {
        //Go back to first column and issue page break
        $this->SetCol(0);
        return true;
    }
}

function PDF($orientation='P',$unit='mm',$format='A4')
{
	//Call parent constructor
	$this->FPDF($orientation,$unit,$format);
	//Initialization
	$this->B=0;
	$this->I=0;
	$this->U=0;
	$this->HREF='';
}

function WriteHTML($html)
{
	//HTML parser
	$html=str_replace("\n",' ',$html);
	$a=preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE);
	foreach($a as $i=>$e)
	{
		if($i%2==0)
		{
			//Text
			if($this->HREF)
				$this->PutLink($this->HREF,$e);
			else
				$this->Write(5,$e);
		}
		else
		{
			//Tag
			if($e{0}=='/')
				$this->CloseTag(strtoupper(substr($e,1)));
			else
			{
				//Extract attributes
				$a2=explode(' ',$e);
				$tag=strtoupper(array_shift($a2));
				$attr=array();
				foreach($a2 as $v)
					if(ereg('^([^=]*)=["\']?([^"\']*)["\']?$',$v,$a3))
						$attr[strtoupper($a3[1])]=$a3[2];
				$this->OpenTag($tag,$attr);
			}
		}
	}
}

function OpenTag($tag,$attr)
{
	//Opening tag
	if($tag=='B' or $tag=='I' or $tag=='U')
		$this->SetStyle($tag,true);
	if($tag=='A')
		$this->HREF=$attr['HREF'];
	if($tag=='BR')
		$this->Ln(5);
}

function CloseTag($tag)
{
	//Closing tag
	if($tag=='B' or $tag=='I' or $tag=='U')
		$this->SetStyle($tag,false);
	if($tag=='A')
		$this->HREF='';
}

function SetStyle($tag,$enable)
{
	//Modify style and select corresponding font
	$this->$tag+=($enable ? 1 : -1);
	$style='';
	foreach(array('B','I','U') as $s)
		if($this->$s>0)
			$style.=$s;
	$this->SetFont('',$style);
}

function PutLink($URL,$txt)
{
	//Put a hyperlink
	$this->SetTextColor(0,0,255);
	$this->SetStyle('U',true);
	$this->Write(5,$txt,$URL);
	$this->SetStyle('U',false);
	$this->SetTextColor(0);
}
function Headers($html="xxx")
 {
 $this->AddPage();
	$this->SetFont('uni','',14);
	$this->SetLeftMargin(0.0);$this->SetRightMargin(0.0);$this->SetTopMargin(0.0);
	$this->SetAutoPageBreak('off' ,0.0) ;	//default (on ,2cm)在底部(20)
	$this->SetY(12.0);$this->SetX(5.0);
	$this->MultiCell(100,6, "$html" ,0); ;

 }
 function AutoPrint($prtName="HP DeskJet 695C")
{
	//Embed some JavaScript to show the print dialog or start printing immediately
	//$param=($dialog ? 'true' : 'false');
 $script = "var pp=this.getPrintParams();\n" ;
 $script .= "pp.interactive=pp.constants.interactionLevel.automatic;" ;
  $script .= "fv=pp.constants.flagValues;" ;

   $script .= "var r, re;\n" ;
   $script .= "   re = new RegExp('$prtName',\"i\");\n" ;
  $script .= "	var l = app.printerNames.length;\n" ;
 $script .="for ( var i = 0; i < l; i++){" ;
$script .= "   var s = app.printerNames[i];\n" ;
 //echo "   re = new RegExp(\"HP DeskJet 695C\",\"i\");\n" ;
 $script .= "   r = s.match(re);\n" ;
     $script .="if(r!=null){\n";
// $script .= "app.alert(app.printerNames[i]);" ;
 $script .= "pp.printerName=app.printerNames[i];\n" ;
 $script .= "pp.flags |= (fv.suppressCenter | fv.suppressRotate);\n";//don't rotate & center
 $script .= "pp.flags = pp.flags | fv.setPageSize;\n" ;//使用軟體定義紙
 
  $script .= "this.print(pp);" ;
  $script .= "break;";
     $script .= "}\n" ;
 $script .= "}\n" ;
 $script .="if(r==null){ print('true');}";
//app.alert(\"Can't find printer $prtName ,\\n\\n Please check your printers setting.\");
	$this->IncludeJS($script);
}
}
//==============end class/
$xylen=array(80.0,140.0);
$pdf=new PDF("P","mm",$xylen);
//$pdf->SetFontSize(14);
$pdf->AddBig5Font();
$pdf->Open();


$v_year=date("Y");$v_month=date("m");
$v_date_time=date("Y-m-d H:i");
$v_date=date("Y-m-d");

for ($i=1;$i<=3;$i++){

     $v_inv="sep".$i."_invno";
	 
   if(isset($$v_inv)){
	    $pdf->AddPage();
        //$pdf->SetFont('uni','B',12);
        //$pdf->Headers($room_no, $m_cidno, $v_name, $ci_date,$to_day);    $pdf->SetY(80);
	    $pdf->SetLeftMargin(6.0);$pdf->SetRightMargin(0.0);$pdf->SetTopMargin(20.0);
	    $pdf->SetAutoPageBreak('off' ,0.0) ;	//default (on ,2cm)在底部(20)
		//$pdf->SetXY(4.0,45.0);//$pdf->SetX(5.0);date("Y-m-d");
     //================================================================
	 $m_inv=$$v_inv;
     $invcode=substr($m_inv,0,2);
     $invseq=substr($m_inv,2,8);

     $v_midno="sep".$i."_midno";
	 $m_midno=$$v_midno;
     $v_name="sep".$i."_name";
	 $m_name=$$v_name;

     $v_tot_ar="sep".$i."_tot_ar";//
          $v_tot_ar_001="sep".$i."_tot_ar_001";//
	      $v_tot_ar_002="sep".$i."_tot_ar_002";//
		  $v_tot_ar_003="sep".$i."_tot_ar_003";//
	 $v_tot="sep".$i."_tot";

	 $m_tot_ar=$$v_tot;
	 if(empty($m_tot_ar))$m_tot_ar=$$v_tot_ar;

     //$m_type="1";
	 //if (!empty($m_midno)){$m_type="2";}
	 if(empty($inv_type)){
       $inv_type="1";
	    if (!empty($m_midno)){$inv_type="2";}
	 }

     $sql="update invoice set inv_status='3' ,inv_date='$v_date' , inv_money='$m_tot_ar' , ";
	 $sql.=" cust_name='$m_name' , inv_busino='$m_midno' ,inv_type='$inv_type' ,room_no='$room_no',ci_no='$ci_no' ";
	 $sql.=" where hid='$hid' and inv_year='$v_year' and inv_month='$v_month'";
     $sql.=" and inv_code='$invcode' and inv_seq='$invseq' ";
     $rs= &$conn->Execute($sql);//print_r ($rs);
//	 echo $sql."<br>";
     if (empty($rs)){
         echo "檔案開啟錯誤 invoice HFS-inv-print1 03";
         exit ;
     }

	 if(empty($rs->_numOfRows)){
     $sql="insert into invoice   ";
     $sql.=" ( hid, inv_code, inv_seq, inv_year, inv_month, inv_date, ";
     $sql.=" inv_money, inv_tax, inv_type, inv_status, cust_name, inv_busino, room_no,ci_no,inv_remark ) ";
     $sql.=" values  ";
     $sql.=" ('$hid', '$invcode', '$invseq', '$v_year', '$v_month', '$v_date', ";
     $sql.=" '$m_tot_ar', 0, '$inv_type', '3', '$m_name', '$m_midno','$room_no','$ci_no', '' ) ";
     $rs= &$conn->Execute($sql);
      if( empty($rs)){echo "發票資料寫入錯誤";exit;}
     }
	 /*$sep_yn為拆帳作業判斷的旗標*/
     if ($sep_yn=="Y"){
        $condi=" and sep_seq='$i'  ";
     }
	 else{
		 $condi="";
	 }

	 $sql="update salemaster set inv_yn='Y',inv_no='$m_inv'  where hid='$hid' and ci_no='$ci_no' and inv_yn='N'  $condi ";//要讓交易主檔呈現已開發票的狀況
     $rs= &$conn->Execute($sql);
//	 	 echo $sql."<br>";

     if (empty($rs)){
          echo "檔案開啟錯誤 salemaster HFS-inv-print1 03";
         exit ;
     }
	 //===========================================================
	$sqlglo = "select * from ".$tpl_prefix."admsetup ";
    $rsglo = $conn->Execute($sqlglo);
    if (!empty($rsglo)) {
	         $inv_coname = $rsglo->fields("inv_coname");
	}
	      $pdf->SetFont('Times','',12); 
     $pdf->Cell(0,6, $v_date_time ,0);$pdf->Ln();
	      $pdf->SetFont('uni','',12);
     $pdf->Cell(0,6, "公司:  "."$inv_coname" ,0);$pdf->Ln();//$COM_NAME
	 $pdf->Cell(19,6, "統一編號: ",0);
          $pdf->SetFont('Times','',12); 
	  $pdf->Cell(0,6,"$m_midno" ,0);$pdf->Ln();
	 $pdf->Cell(0,6, "ci_no:".$ci_no ,0);$pdf->Ln();

             $pdf->SetFont('uni','',12);
	 $pdf->Cell(0,6, "消費項目:",0);$pdf->Ln();
     
	 //$pdf->Cell(10,6, "$inv_item " ,0);
	 //       $pdf->SetFont('Times','',12); 
	 //$pdf->Cell(0,6, "$m_tot_ar" ,0); $pdf->Ln();
	       $pdf->SetFont('Times','',12); 
	 if(!empty($$v_tot_ar_001)){
	 $pdf->Cell(0,6, "001     ".$$v_tot_ar_001 ,0); $pdf->Ln();
	 }
	 if(!empty($$v_tot_ar_002)){
	 $pdf->Cell(0,6, "002     ".$$v_tot_ar_002 ,0); $pdf->Ln();
	 }
	 if(!empty($$v_tot_ar_003)){
	 $pdf->Cell(0,6, "003     ".$$v_tot_ar_003 ,0); $pdf->Ln();
	 }
	 if(($m_tot_ar-$$v_tot_ar) != 0){
	 $pdf->Cell(0,6, "004     ".($m_tot_ar-$$v_tot_ar) ,0); $pdf->Ln();
	 }
             $pdf->SetFont('uni','',12);
	 $pdf->Cell(10,6, "總計: " ,0);
	             $pdf->SetFont('Times','',12); 
	 $pdf->Cell(0,6, "$m_tot_ar" ,0);$pdf->Ln();
	 //=========================================
   }

}

//echo '1234';
//==========================

        $prg_code=basename(__FILE__);
$sql ="select * ,LENGTH(print_hostip) as len  from tpl_printer where instr('$REMOTE_ADDR',print_hostip)<> 0 and prg_code='$prg_code' ";
        //$sql = "select *  from   tpl_printer  where prg_code='$prg_code' ";
        $rsp = &$conn->Execute($sql);
		$print_name = $rsp->fields("print_name");
if(!empty($print_name))
$pdf->AutoPrint("$print_name");

$pdf->Output();
?>
