<?php 
include ("../glbinc.inc");
$lprg_code="ord_source.php";
include_once($inc_path."authen.inc");
include($inc_path."fpdf/chinese.php");

//==========pdf class

class PDF_MySQL_Table extends PDF_Chinese
{
var $ProcessingTable=false;
var $aCols=array();
var $TableX;
var $HeaderColor;
var $RowColors;
var $ColorIndex;
var $db = null;//adodb
function setdb(&$conn)
{
	    if ($conn){
               $this->db = $conn;
          /*選擇存取的table files*/
        } else {
           if (!$conn) {
            die('連線尚未設定!');
           } else {
            die ('找不到資料庫!');
           }
	    }
}
function Header()
{
    //Print the table header if necessary
    if($this->ProcessingTable)
        $this->TableHeader();
}

function TableHeader()
{
    $this->SetFont('uni','B',12);
    $this->SetX($this->TableX);
    $fill=!empty($this->HeaderColor);
    if($fill)
        $this->SetFillColor($this->HeaderColor[0],$this->HeaderColor[1],$this->HeaderColor[2]);
    foreach($this->aCols as $col)
        $this->Cell($col['w'],6,$col['c'],1,0,$col['a'],$fill);
    $this->Ln();
}

function Row($data)
{
    $this->SetX($this->TableX);
    $ci=$this->ColorIndex;
    $fill=!empty($this->RowColors[$ci]);
    if($fill)
        $this->SetFillColor($this->RowColors[$ci][0],$this->RowColors[$ci][1],$this->RowColors[$ci][2]);
    foreach($this->aCols as $col)
    {
	if(!is_array($col['r'])){
        $this->Cell($col['w'],5,$data[$col['f']],1,0,$col['a'],$fill);
	}else{
	  $refn=$col['r'];
	  //global $$refn;
	  //$refname=$$refn;
        $this->Cell($col['w'],5,$refn[$data[$col['f']]],1,0,$col['a'],$fill);		
	}
    }
    $this->Ln();
    $this->ColorIndex=1-$ci;
}

function CalcWidths($width,$align)
{
    //Compute the widths of the columns
    $TableWidth=0;
    foreach($this->aCols as $i=>$col)
    {
        $w=$col['w'];
        if($w==-1)
            $w=$width/count($this->aCols);
        elseif(substr($w,-1)=='%')
            $w=$w/100*$width;
        $this->aCols[$i]['w']=$w;
        $TableWidth+=$w;
    }
    //Compute the abscissa of the table
    if($align=='C')
        $this->TableX=max(($this->w-$TableWidth)/2,0);
    elseif($align=='R')
        $this->TableX=max($this->w-$this->rMargin-$TableWidth,0);
    else
        $this->TableX=$this->lMargin;
}

function AddCol($field=-1,$width=-1,$caption='',$align='L',$ref='')
{
    //Add a column to the table
    if($field==-1)
        $field=count($this->aCols);
    $this->aCols[]=array('f'=>$field,'c'=>$caption,'w'=>$width,'a'=>$align,'r'=>$ref);
}

function Table($query,$prop=array())
{
	global $conn;
	if(!empty($conn)){$this->setdb($conn);}
    //Issue query
    $res=$this->db->Execute($query) or die('Error: '.mysql_error()."<BR>Query: $query");
    //Add all columns if none was specified
    if(count($this->aCols)==0)
    {
        //$nb=mysql_num_fields($res);
		$nb=$res->FieldCount();
        for($i=0;$i<$nb;$i++)
            $this->AddCol();
    }
    //Retrieve column names when not specified
    foreach($this->aCols as $i=>$col)
    {
        if($col['c']=='')
        {
            if(is_string($col['f'])){
                $this->aCols[$i]['c']=ucfirst($col['f']);
            }else{
                //$this->aCols[$i]['c']=ucfirst(mysql_field_name($res,$col['f']));
                  $fj  = $res->FetchField($col['f']);
			    $this->aCols[$i]['c']=ucfirst($fj->name);
			}
        }
    }
    //Handle properties
    if(!isset($prop['width']))
        $prop['width']=0;
    if($prop['width']==0)
        $prop['width']=$this->w-$this->lMargin-$this->rMargin;
    if(!isset($prop['align']))
        $prop['align']='C';
    if(!isset($prop['padding']))
        $prop['padding']=$this->cMargin;
    $cMargin=$this->cMargin;
    $this->cMargin=$prop['padding'];
    if(!isset($prop['HeaderColor']))
        $prop['HeaderColor']=array();
    $this->HeaderColor=$prop['HeaderColor'];
    if(!isset($prop['color1']))
        $prop['color1']=array();
    if(!isset($prop['color2']))
        $prop['color2']=array();
    $this->RowColors=array($prop['color1'],$prop['color2']);
    //Compute column widths
    $this->CalcWidths($prop['width'],$prop['align']);
    //Print header
    $this->TableHeader();
    //Print rows
    $this->SetFont('uni','',11);
    $this->ColorIndex=0;
    $this->ProcessingTable=true;
	//while($row=mysql_fetch_array($res))
	while($row=$res->FetchRow())
            $this->Row($row);
    $this->ProcessingTable=false;
    $this->cMargin=$cMargin;
    $this->aCols=array();
}
}
class PDF extends PDF_MySQL_Table
{
var $title,$pgname,$print_name,$cond;
function Header()
{
    //Title
    $this->SetTextColor(0,0,0);
    
	  $this->setX($this->lMargin);
    $this->SetFont('uni','B',14);
    $this->Ln();
    $this->Cell(0,2,$this->title,0,1,'C');
    $this->Ln(4);

    
	  $this->setX($this->lMargin);
    $this->SetFont('uni','B',12);
    $this->Cell(0,2,'通路來源統計表',0,1,'C');
    
	  $this->setX($this->rMargin-50);
    $this->Cell(0,2,'製表人 :'.$this->print_name,0,0,'C');
    
    $this->Ln(6);

    
    //$this->SetFont('Arial','',18);


  $this->SetFont('uni','B',11);
	$this->setX($this->lMargin);
	$ptime='印表時間: '.date("Y/m/d H:i");
	$this->Cell(10,2,$ptime,0,0,'L');
	
	
	$this->setX($this->rMargin-50);
	$this->Cell(0,2,'頁次: '.$this->PageNo().'/{nb}',0,0,'L');
//	$this->Cell(0,6,'頁次: '.$this->PageNo().'/'.$this->page,0,0,'L');
    $this->Ln(5);

    //==========Column Header
    $this->SetFont('uni','',10);

    $this->Cell(60,6,"代辦旅行社",1,0,'C');
    $this->Cell(30,6,"聯絡人",1,0,'C');
    $this->Cell(20,6,"訂房日期",1,0,'C');
    $this->Cell(40,6,"團體名稱",1,0,'C');
    $this->Cell(20,6,"房間數",1,0,'C');
    $this->Cell(20,6,"金額",1,0,'C');
	  $this->Ln();
    //Ensure table header is output
    parent::Header();
}
}

//====end class
  $s_date=$_POST['s_date'];
  $e_date=$_POST['e_date'];
  $sql="select *,sum(rd_room_qty) rd_room_qty, sum(s_amt) s_amt from greserv where hid='$hid' and agency_name is not null and agency_name!='' and rd_date between '$s_date' and '$e_date' group by agency_no,agency_name,rd_date";
  $rs= &$conn->Execute($sql);
  if($rs === false){
	 saymsg('訂房資料讀取錯誤 greserv');
    exit;
	}
	
	
  if ($rs->rowcount()==0) {
        print ($strMeta."<h3>查 無 資 料.</h3><br>");
        exit;
    }
	
//=======================
//====開啟pdf
//$xylen=array(110.0,155.0);//25.54*6=155
// L 橫式 P 直式
if (empty($p_size)) $p_size='A4';
$pdf=new PDF("P","mm",$p_size);
//$pdf->SetFontSize(14);
$pdf->AliasNbPages();
$pdf->AddBig5Font();
$pdf->SetLineWidth(0.1);  	
$pdf->SetAutoPageBreak(true,5.0);
$pdf->Open();

/*****讀取 設定值   *******/
  $sqlstr="select * from admsetup";
  $rsstr=&$conn->Execute($sqlstr);
  if ($rsstr->Rowcount()==0) {
	  $pdf->title='admsetup 無公司名稱';
  } else {
    $pdf->title=$rsstr->fields("hname");
  }	
  $pdf->print_name = $_SESSION['PHP_AUTH_USER'];      

	//$pdf->SetLeftMargin(5);
	$pdf->SetTopMargin(5); 
	$pdf->AddPage();
	$pdf->AliasNbPages();
  $pdf->SetFont('uni','',11);
	//$lwidth=$pdf->w - $pdf->lMargin;

   while(!$rs->EOF){
	    $agency_name = $rs->fields['agency_name'];
	    $contact = $rs->fields['contact'];
	    $rd_date = $rs->fields['rd_date'];
	    $v_name = $rs->fields['v_name'];
	    $rd_room_qty = $rs->fields['rd_room_qty'];
	    $s_amt = $rs->fields['s_amt'];
      $pdf->Cell(60,6,"$agency_name",1,0,'L');
      $pdf->Cell(30,6,"$contact",1,0,'L');
      $pdf->Cell(20,6,"$rd_date",1,0,'C');
      $pdf->Cell(40,6,"$v_name",1,0,'L');
      $pdf->Cell(20,6,"$rd_room_qty",1,0,'R');
      $pdf->Cell(20,6,"$s_amt",1,0,'R');
      $pdf->Ln();

		  $rs->movenext();
	 }


//	$pdf->SetFont('uni','B',11);
//	$pdf->Cell(0,6,">>>共 $rows 筆<<<",0,1,'C');
	$pdf->Output();
?>
